<?xml version="1.0" encoding="UTF-8"?>

<!--        
  - New SpringViz by Erik Doernenburg (http://erik.doernenburg.com)
  - Based on the XSLT stylesheet by Mike Thomas (http://www.samoht.com)   
  -
  - Look for comments containing two asterisks (**), these are places where
  - you might want to add your own customisations, the ones included here
  - are just examples.
  -->     

<xsl:stylesheet version="1.0"
	xmlns:s="http://www.springframework.org/schema/beans"
	xmlns:aop="http://www.springframework.org/schema/aop"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="
		http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
		http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.0.xsd">

	<xsl:param name="filename" select="'UNKNOWN_FILE'"/>
    <xsl:output method="text"/>

    <xsl:template match="/">
    subgraph "cluster_<xsl:value-of select="$filename"/>" { 
    	label="<xsl:value-of select='$filename'/>";
    	style=filled;
    	color=ivory3;
        <xsl:apply-templates select="s:beans/s:bean"/>
       	<xsl:apply-templates select="s:beans//s:bean/s:property//s:ref"/>
        <xsl:apply-templates select="s:beans//s:bean/s:property/@ref"/>
        <xsl:apply-templates select="s:beans//s:bean/s:constructor-arg//s:ref"/>
        <xsl:apply-templates select="s:beans//s:bean/s:constructor-arg/@ref"/>
    }
    </xsl:template>

    <!-- Generates all the nodes so that their attributes can be set -->
    <xsl:template match="s:bean">
 
        <!-- Start the bean node -->
        <xsl:text>"</xsl:text> 
		<xsl:value-of select="@id"/>
		<xsl:value-of select="@name"/>
        <xsl:text>"</xsl:text>
        <xsl:text> [</xsl:text>     

        <!-- Colourise the graph ** -->
        <xsl:choose>
          	<xsl:when test="contains(@class, 'org.springframework.samples.jpetstore')">color=maroon</xsl:when>
          	<xsl:when test="contains(@class, 'org.springframework.web')">color=chartreuse1</xsl:when>
          	<xsl:when test="contains(@class, 'org.springframework.orm')">color=chartreuse3</xsl:when>
          	<xsl:when test="contains(@class, 'org.springframework')">color=chartreuse2</xsl:when>
        </xsl:choose>

        <xsl:text>];
        </xsl:text>

    </xsl:template>
                      
    <!-- Generates the lines between the nodes for ref attributes on nested elements -->
    <xsl:template match="@ref">
        <xsl:text>"</xsl:text>
		<xsl:value-of select="ancestor::s:bean/@id"/>
		<xsl:value-of select="ancestor::s:bean/@name"/>
        <xsl:text>"</xsl:text>
        <xsl:text> -&gt; </xsl:text>
        <xsl:text>"</xsl:text>
		<xsl:choose>             
	        <!-- horrible hack below - I don't know XSLT! -->
			<xsl:when test=". = ."><xsl:value-of select="."/></xsl:when>
		</xsl:choose>
        <xsl:text>"</xsl:text>
        <xsl:text> [</xsl:text>
        <xsl:text>];</xsl:text>
        <xsl:text>
        </xsl:text>
    </xsl:template>
    
    <!-- Generates the lines between the nodes for nexted ref elements (rare) -->
    <xsl:template match="s:ref">
        <xsl:text>"</xsl:text>
        <xsl:value-of select="ancestor::s:bean/@id"/>
 		<xsl:value-of select="ancestor::s:bean/@name"/>
       <xsl:text>"</xsl:text>
        <xsl:text> -&gt; </xsl:text>
        <xsl:text>"</xsl:text>
        <xsl:value-of select="@bean"/>
        <xsl:value-of select="@ref"/>
        <xsl:value-of select="@local"/>
        <xsl:text>"</xsl:text>
        <xsl:text> [</xsl:text>
        <xsl:text>];</xsl:text>
        <xsl:text>
        </xsl:text>
    </xsl:template>

</xsl:stylesheet>

